# Compare FEM solution to exact solution
# Compute harmonic solution with fenics prior to running this script.
# Computation of harmonic solution can be done with `fenics_reference_solution.py`

import math
import matplotlib.pyplot as plt

cl_ext = 1
cl_int = 0
solution_file = "fenics_harmonic_solution.log"

def potentiel_harmonique(z):
    A = -(cl_int - cl_ext)/math.log(2)
    B = abs((2*z - 1)/(z-2))
    return A * math.log(B) + cl_ext


# Read FEM solution from file
xx = []
yy = []
zmef = []
with open(solution_file, 'r') as input:
    input.next() # ignore first line from FEniCS output
    for line in input:
        tmp = line.split()
        xx.append(float(tmp[0]))
        yy.append(float(tmp[1]))
        zmef.append(float(tmp[2]))

res = []
# Compare to exact solution
for x, y, zmef in zip (xx, yy, zmef):
    point = x + 1j*y
    test = potentiel_harmonique(point)

    tmp = abs(test-zmef)
    res.append(tmp)
    print tmp

print "moyenne", math.log(sum(res)/len(res))/math.log(10.)
