# Plot function g over \Omega
import matplotlib.pyplot as plt

from green import *


# Test case geometry
centres = [0, 0.5j, -0.2-0.5j, -0.3, 0.3] # Outer circle is first in list
rayons = [1., 0.2, 0.1, 0.1, 0.1]
delta = 0.105 
if (len(centres) != len(rayons)):
    print "Verifier nombre de cercles"
if (point_exterieur(delta, centres, rayons)):
    print "Verifier le centre de la fonction de Green"
for cen, ray in zip(centres[1:], rayons[1:]):
    if (abs(cen-centres[0])+ray > rayons[0]):
        print "Verifier que le premier cercle est exterieur aux autres"

# Parameters for building the Green's function
N = 10 # Laurent expansion
npts = 30 # Collocation points

# Green's function in delta
centres_T, rayons_T = inversion_domaine(centres, rayons, delta)
z_T = points_collocation(centres_T, rayons_T, npts)
a,b,d,e = coeffs_harmonique(centres_T, N, z_T)

g_delta = fonction_green(centres, rayons, delta, centres_T, a,b,d,e)

# Grid of points
xmin = -1.
xmax = 1.
xstep = 0.01
xvals = np.arange(xmin, xmax, xstep)
xpos = [x+1j*y for x in xvals for y in xvals
        if point_interieur(x+1j*y, centres, rayons)]

zres = []
for point in xpos:
    tmp = g_delta(point)
    zres.append(tmp)

# Plot results
xx = [e.real for e in xpos]
yy = [e.imag for e in xpos]
sc = plt.scatter(xx, yy, c=zres, edgecolors='none')
plt.colorbar(sc)
plt.gca().set_aspect('equal', adjustable='box')
plt.title("G(x, .), x = "+str(delta))
plt.show()
