from green import *
import time


# Test case geometry
centres = [0, 0.5j, -0.2-0.5j, -0.3, 0.3] # Outer circle is first in list
rayons = [1., 0.2, 0.1, 0.1, 0.1]
delta = 0.105
if (len(centres) != len(rayons)):
    print "Verifier nombre de cercles"
if (point_exterieur(delta, centres, rayons)):
    print "Verifier le centre de la fonction de Green"
for cen, ray in zip(centres[1:], rayons[1:]):
    if (abs(cen-centres[0])+ray > rayons[0]):
        print "Verifier que le premier cercle est exterieur aux autres"

# Parameters for building the Green's function
Nlist = [2,5,10] # Laurent expansion
nptslist = [2,4,8,16,32,64] # Collocation points

# Green's function in delta
def fun(N, npts):
    centres_T, rayons_T = inversion_domaine(centres, rayons, delta)
    z_T = points_collocation(centres_T, rayons_T, npts)
    a,b,d,e = coeffs_harmonique(centres_T, N, z_T)
    
    g_delta = fonction_green(centres, rayons, delta, centres_T, a,b,d,e)

    
print "N, npts, temps (s)"
niterations=1000
for N in Nlist:
    for npts in nptslist:
        start = time.time()
        for i in range(niterations):
            fun(N, npts)
        res = (time.time()-start)/niterations
        
        print N, npts, res
